    001    /*
    002     * Copyright (C) 2007 The Guava Authors
    003     *
    004     * Licensed under the Apache License, Version 2.0 (the "License");
    005     * you may not use this file except in compliance with the License.
    006     * You may obtain a copy of the License at
    007     *
    008     * http://www.apache.org/licenses/LICENSE-2.0
    009     *
    010     * Unless required by applicable law or agreed to in writing, software
    011     * distributed under the License is distributed on an "AS IS" BASIS,
    012     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    013     * See the License for the specific language governing permissions and
    014     * limitations under the License.
    015     */
    016
    017    package com.google.common.base;
    018
    019    import java.lang.ref.ReferenceQueue;
    020    import java.lang.ref.SoftReference;
    021
    022    /**
    023     * Soft reference with a {@code finalizeReferent()} method which a background thread invokes after
    024     * the garbage collector reclaims the referent. This is a simpler alternative to using a {@link
    025     * ReferenceQueue}.
    026     *
    027     * @author Bob Lee
    028     * @since 2.0 (imported from Google Collections Library)
    029     */
    030    public abstract class FinalizableSoftReference<T> extends SoftReference<T>
    031        implements FinalizableReference {
    032      /**
    033       * Constructs a new finalizable soft reference.
    034       *
    035       * @param referent to softly reference
    036       * @param queue that should finalize the referent
    037       */
    038      protected FinalizableSoftReference(T referent, FinalizableReferenceQueue queue) {
    039        super(referent, queue.queue);
    040        queue.cleanUp();
    041      }
    042    }